Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 1326)
+++ /palm/trunk/SOURCE/modules.f90	(revision 1327)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! REAL constants defined as wp-kind
+! -avs_output, data_output_format, do3d_compress, iso2d_output, netcdf_output
 !
 ! Former revisions:
@@ -347,64 +348,64 @@
                 
 
-    REAL(wp) ::  a_1 = 8.69E-4,     & !: coef. in turb. parametrization (cm-2 s3)
-                 a_2 = -7.38E-5,    & !: coef. in turb. parametrization (cm-2 s3)
-                 a_3 = -1.40E-2,    & !: coef. in turb. parametrization
-                 a_term = 9.65,     & !: coef. for terminal velocity (m s-1)
-                 a_vent = 0.78,     & !: coef. for ventilation effect
-                 b_1 = 11.45E-6,    & !: coef. in turb. parametrization (m)
-                 b_2 = 9.68E-6,     & !: coef. in turb. parametrization (m)
-                 b_3 = 0.62,        & !: coef. in turb. parametrization
-                 b_term = 9.8,      & !: coef. for terminal velocity (m s-1)
-                 b_vent = 0.308,    & !: coef. for ventilation effect
-                 beta_cc = 3.09E-4, & !: coef. in turb. parametrization (cm-2 s3)
+    REAL(wp) ::  a_1 = 8.69E-4_wp,     & !: coef. in turb. parametrization (cm-2 s3)
+                 a_2 = -7.38E-5_wp,    & !: coef. in turb. parametrization (cm-2 s3)
+                 a_3 = -1.40E-2_wp,    & !: coef. in turb. parametrization
+                 a_term = 9.65_wp,     & !: coef. for terminal velocity (m s-1)
+                 a_vent = 0.78_wp,     & !: coef. for ventilation effect
+                 b_1 = 11.45E-6_wp,    & !: coef. in turb. parametrization (m)
+                 b_2 = 9.68E-6_wp,     & !: coef. in turb. parametrization (m)
+                 b_3 = 0.62_wp,        & !: coef. in turb. parametrization
+                 b_term = 9.8_wp,      & !: coef. for terminal velocity (m s-1)
+                 b_vent = 0.308_wp,    & !: coef. for ventilation effect
+                 beta_cc = 3.09E-4_wp, & !: coef. in turb. parametrization (cm-2 s3)
                  bfactor,           &
-                 c_1 = 4.82E-6,     & !: coef. in turb. parametrization (m)
-                 c_2 = 4.8E-6,      & !: coef. in turb. parametrization (m)
-                 c_3 = 0.76,        & !: coef. in turb. parametrization
-                 c_const = 0.93,    & !: const. in Taylor-microscale Reynolds number
-                 c_evap = 0.7,      & !: constant in evaporation
-                 c_sedimentation = 2.0, & !: Courant number of sedimentation process
-                 c_term = 600.0,    & !: coef. for terminal velocity (m-1)
-                 cof(6) = (/ 76.18009172947146,      & !: coefficients in the 
-                             -86.50532032941677,     & !: numerical
-                             24.01409824083091,      & !: calculation of the
-                             -1.231739572450155,     & !: gamma function
-                             0.1208650973866179E-2,  &
-                             -0.5395239384953E-5 /), &
-                cp = 1005.0,       & !: heat capacity of dry air (J kg-1 K-1) 
-                diff_coeff_l = 0.23E-4, & !: diffusivity of water vapor (m2 s-1)
+                 c_1 = 4.82E-6_wp,     & !: coef. in turb. parametrization (m)
+                 c_2 = 4.8E-6_wp,      & !: coef. in turb. parametrization (m)
+                 c_3 = 0.76_wp,        & !: coef. in turb. parametrization
+                 c_const = 0.93_wp,    & !: const. in Taylor-microscale Reynolds number
+                 c_evap = 0.7_wp,      & !: constant in evaporation
+                 c_sedimentation = 2.0_wp, & !: Courant number of sedimentation process
+                 c_term = 600.0_wp,    & !: coef. for terminal velocity (m-1)
+                 cof(6) = (/ 76.18009172947146_wp,      & !: coefficients in the 
+                             -86.50532032941677_wp,     & !: numerical
+                             24.01409824083091_wp,      & !: calculation of the
+                             -1.231739572450155_wp,     & !: gamma function
+                             0.1208650973866179E-2_wp,  &
+                             -0.5395239384953E-5_wp /), &
+                cp = 1005.0_wp,       & !: heat capacity of dry air (J kg-1 K-1) 
+                diff_coeff_l = 0.23E-4_wp, & !: diffusivity of water vapor (m2 s-1)
                 effective_coll_efficiency, & !:
-                eps_ros = 1.0E-4,  & !: accuracy of Rosenbrock method
-                eps_sb = 1.0E-20,  & !: threshold in two-moments scheme
-                k_cc = 9.44E09,    & !: const. cloud-cloud kernel (m3 kg-2 s-1) 
-                k_cr0 = 4.33,      & !: const. cloud-rain kernel (m3 kg-1 s-1) 
-                k_rr = 7.12,       & !: const. rain-rain kernel (m3 kg-1 s-1) 
-                k_br = 1000.,      & !: const. in breakup parametrization (m-1)
-                k_st = 1.2E8,      & !: const. in drizzle parametrization (m-1 s-1)
-                kappa_rr = 60.7,   & !: const. in collision kernel (kg-1/3)
-                kin_vis_air = 1.4086E-5, & !: kin. viscosity of air (m2 s-1)
-                l_v = 2.5E+06,     & !: latent heat of vaporization (J kg-1)
+                eps_ros = 1.0E-4_wp,  & !: accuracy of Rosenbrock method
+                eps_sb = 1.0E-20_wp,  & !: threshold in two-moments scheme
+                k_cc = 9.44E09_wp,    & !: const. cloud-cloud kernel (m3 kg-2 s-1) 
+                k_cr0 = 4.33_wp,      & !: const. cloud-rain kernel (m3 kg-1 s-1) 
+                k_rr = 7.12_wp,       & !: const. rain-rain kernel (m3 kg-1 s-1) 
+                k_br = 1000._wp,      & !: const. in breakup parametrization (m-1)
+                k_st = 1.2E8_wp,      & !: const. in drizzle parametrization (m-1 s-1)
+                kappa_rr = 60.7_wp,   & !: const. in collision kernel (kg-1/3)
+                kin_vis_air = 1.4086E-5_wp, & !: kin. viscosity of air (m2 s-1)
+                l_v = 2.5E+06_wp,     & !: latent heat of vaporization (J kg-1)
                 l_d_cp, l_d_r, l_d_rv, & !: l_v / cp, l_v / r_d, l_v / r_v
-                mass_of_solute = 1.0E-17, & !: soluted NaCl (kg)
-                molecular_weight_of_solute = 0.05844, & !: mol. m. NaCl (kg mol-1)
-                molecular_weight_of_water = 0.01801528, & !: mol. m. H2O (kg mol-1)
-                nc_const = 70.0E6, & !: cloud droplet concentration
-                prec_time_const = 0.001, & !: coef. in Kessler scheme
+                mass_of_solute = 1.0E-17_wp, & !: soluted NaCl (kg)
+                molecular_weight_of_solute = 0.05844_wp, & !: mol. m. NaCl (kg mol-1)
+                molecular_weight_of_water = 0.01801528_wp, & !: mol. m. H2O (kg mol-1)
+                nc_const = 70.0E6_wp, & !: cloud droplet concentration
+                prec_time_const = 0.001_wp, & !: coef. in Kessler scheme
                 pirho_l, dpirho_l, & !: pi * rho_l / 6.0; 6.0 / ( pi * rho_l )
-                rho_l = 1.0E3,     & !: density of water (kg m-3)
-                ql_crit = 0.0005,  & !: coef. in Kessler scheme
-                r_d = 287.0,       & !: sp. gas const. dry air (J kg-1 K-1)
-                r_v = 461.51,      & !: sp. gas const. water vapor (J kg-1 K-1)
-                schmidt = 0.71,    & !: Schmidt number
-                schmidt_p_1d3,     & !: schmidt**( 1.0 / 3.0 )
-                sigma_gc = 1.3,    & !: log-normal geometric standard deviation
-                stp = 2.5066282746310005, & !: parameter in gamma function
-                thermal_conductivity_l = 2.43E-2, & !: therm. cond. air (J m-1 s-1 K-1)
-                vanthoff = 2.0,    & !: van't Hoff factor for NaCl
-                x0 = 2.6E-10,      & !: separating drop mass (kg)
-                xrmin = 2.6E-10,   & !: minimum rain drop size (kg)
-                xrmax = 5.0E-6,    & !: maximum rain drop site (kg)
-                dt_precipitation = 100.0, & !: timestep precipitation (s)
-                w_precipitation = 9.65      !: maximum terminal velocity (m s-1)
+                rho_l = 1.0E3_wp,     & !: density of water (kg m-3)
+                ql_crit = 0.0005_wp,  & !: coef. in Kessler scheme
+                r_d = 287.0_wp,       & !: sp. gas const. dry air (J kg-1 K-1)
+                r_v = 461.51_wp,      & !: sp. gas const. water vapor (J kg-1 K-1)
+                schmidt = 0.71_wp,    & !: Schmidt number
+                schmidt_p_1d3,        & !: schmidt**( 1.0 / 3.0 )
+                sigma_gc = 1.3_wp,    & !: log-normal geometric standard deviation
+                stp = 2.5066282746310005_wp, & !: parameter in gamma function
+                thermal_conductivity_l = 2.43E-2_wp, & !: therm. cond. air (J m-1 s-1 K-1)
+                vanthoff = 2.0_wp,    & !: van't Hoff factor for NaCl
+                x0 = 2.6E-10_wp,      & !: separating drop mass (kg)
+                xrmin = 2.6E-10_wp,   & !: minimum rain drop size (kg)
+                xrmax = 5.0E-6_wp,    & !: maximum rain drop site (kg)
+                dt_precipitation = 100.0_wp, & !: timestep precipitation (s)
+                w_precipitation = 9.65_wp      !: maximum terminal velocity (m s-1)
 
     REAL(wp), DIMENSION(:), ALLOCATABLE     ::  hyrho, pt_d_t, t_d_pt  
@@ -511,6 +512,4 @@
     CHARACTER (LEN=1000) ::  message_string = ' '
 
-    CHARACTER (LEN=7),  DIMENSION(100) ::  do3d_comp_prec = ' '
-    CHARACTER (LEN=10), DIMENSION(10)  ::  data_output_format = ' '
     CHARACTER (LEN=11), DIMENSION(100) ::  data_output = ' ',    &
                                            data_output_user = ' ', doav = ' '
@@ -581,6 +580,5 @@
                     mask_i_global, mask_j_global, mask_k_global
 
-    LOGICAL ::  avs_output = .FALSE., &
-                bc_lr_cyc =.TRUE., bc_lr_dirrad = .FALSE., &
+    LOGICAL ::  bc_lr_cyc =.TRUE., bc_lr_dirrad = .FALSE., &
                 bc_lr_raddir = .FALSE., bc_ns_cyc = .TRUE., &
                 bc_ns_dirrad = .FALSE., bc_ns_raddir = .FALSE.,&
@@ -595,5 +593,5 @@
                 dissipation_control = .FALSE., disturbance_created = .FALSE., &
                 do2d_at_begin = .FALSE., do3d_at_begin = .FALSE., &
-                do3d_compress = .FALSE., do_sum = .FALSE., &
+                do_sum = .FALSE., &
                 dp_external = .FALSE., dp_smooth = .FALSE., &
                 drizzle = .FALSE., dt_fixed = .FALSE., &
@@ -604,10 +602,10 @@
                 inflow_l = .FALSE., inflow_n = .FALSE., &
                 inflow_r = .FALSE., inflow_s = .FALSE., &
-                iso2d_output = .FALSE., large_scale_forcing = .FALSE., &
+                large_scale_forcing = .FALSE., &
                 large_scale_subsidence = .FALSE., lsf_surf = .TRUE., &
                 lsf_vert = .TRUE., lptnudge = .FALSE., lqnudge = .FALSE., &
                 lunudge = .FALSE., lvnudge = .FALSE., lwnudge = .FALSE., &
                 masking_method = .FALSE., mg_switch_to_pe0 = .FALSE., &
-                netcdf_output = .FALSE., neutral = .FALSE., nudging = .FALSE., &
+                neutral = .FALSE., nudging = .FALSE., &
                 ocean = .FALSE., on_device = .FALSE., &
                 outflow_l = .FALSE., outflow_n = .FALSE., outflow_r = .FALSE., &
@@ -632,111 +630,111 @@
                 data_output_yz(0:1) = .FALSE.
 
-    REAL(wp) ::  advected_distance_x = 0.0, advected_distance_y = 0.0, &
-                 alpha_surface = 0.0, atmos_ocean_sign = 1.0, &
-                 averaging_interval = 0.0, averaging_interval_pr = 9999999.9, &
-                 averaging_interval_sp = 9999999.9, bc_pt_t_val, bc_q_t_val, &
-                 bottom_salinityflux = 0.0, &
-                 building_height = 50.0, building_length_x = 50.0, &
-                 building_length_y = 50.0, building_wall_left = 9999999.9, &
-                 building_wall_south = 9999999.9, canyon_height = 50.0, &
-                 canyon_width_x = 9999999.9, canyon_width_y = 9999999.9, &
-                 canyon_wall_left = 9999999.9, canyon_wall_south = 9999999.9, &
-                 cthf = 0.0, cfl_factor = -1.0, cos_alpha_surface, &
-                 coupling_start_time = 0.0, disturbance_amplitude = 0.25, &
-                 disturbance_energy_limit = 0.01, &
-                 disturbance_level_b = -9999999.9, &
-                 disturbance_level_t = -9999999.9, &
-                 dp_level_b = 0.0, drag_coefficient = 0.0, &
-                 dt = -1.0, dt_averaging_input = 0.0, &
-                 dt_averaging_input_pr = 9999999.9, dt_coupling = 9999999.9, &
-                 dt_data_output = 9999999.9, &
-                 dt_data_output_av = 9999999.9, dt_disturb = 9999999.9, &
-                 dt_dopr = 9999999.9, dt_dopr_listing = 9999999.9, &
-                 dt_dopts = 9999999.9, dt_dosp = 9999999.9, dt_dots = 9999999.9, &
-                 dt_do2d_xy = 9999999.9, dt_do2d_xz = 9999999.9, &
-                 dt_do2d_yz = 9999999.9, dt_do3d = 9999999.9, dt_dvrp = 9999999.9, &
-                 dt_max = 20.0, dt_micro = -1.0, dt_restart = 9999999.9, &
-                 dt_run_control = 60.0, dt_3d = -1.0, dz = -1.0, &
-                 dz_max = 9999999.9, dz_stretch_factor = 1.08, &
-                 dz_stretch_level = 100000.0, e_init = 0.0, e_min = 0.0, &
-                 end_time = 0.0, &
-                 f = 0.0, fs = 0.0, g = 9.81, inflow_damping_height = 9999999.9, &
-                 inflow_damping_width = 9999999.9, kappa = 0.4, km_constant = -1.0,&
-                 lad_surface = 0.0, leaf_surface_concentration = 0.0, &
-                 mask_scale_x = 1.0, mask_scale_y = 1.0, mask_scale_z = 1.0, &
-                 maximum_cpu_time_allowed = 0.0,  &
-                 molecular_viscosity = 1.461E-5, &
-                 old_dt = 1.0E-10, omega = 7.29212E-5, omega_sor = 1.8, &
-                 particle_maximum_age = 9999999.9, &
-                 phi = 55.0, prandtl_number = 1.0, &
-                 precipitation_amount_interval = 9999999.9, prho_reference, &
-                 pt_damping_factor = 0.0, pt_damping_width = 0.0, &
-                 pt_reference = 9999999.9, pt_slope_offset = 0.0, &
-                 pt_surface = 300.0, pt_surface_initial_change = 0.0, &
-                 q_surface = 0.0, q_surface_initial_change = 0.0, &
-                 rayleigh_damping_factor = -1.0, rayleigh_damping_height = -1.0, &
-                 recycling_width = 9999999.9, residual_limit = 1.0E-4, &
-                 restart_time = 9999999.9, rho_reference, rho_surface, &
-                 rif_max = 1.0, rif_min = -5.0, roughness_length = 0.1, &
-                 sa_surface = 35.0, scalar_exchange_coefficient = 0.0, &
-                 simulated_time = 0.0, simulated_time_at_begin, sin_alpha_surface, &
-                 skip_time_data_output = 0.0, skip_time_data_output_av = 9999999.9,&
-                 skip_time_dopr = 9999999.9, skip_time_dosp = 9999999.9, &
-                 skip_time_do2d_xy = 9999999.9, skip_time_do2d_xz = 9999999.9, &
-                 skip_time_do2d_yz = 9999999.9, skip_time_do3d = 9999999.9, &
-                 surface_heatflux = 9999999.9, surface_pressure = 1013.25, &
-                 surface_scalarflux = 9999999.9, surface_waterflux = 9999999.9, &
-                 s_surface = 0.0, s_surface_initial_change = 0.0, &
-                 termination_time_needed = -1.0, time_coupling = 0.0, &
-                 time_disturb = 0.0, time_dopr = 0.0, time_dopr_av = 0.0, &
-                 time_dopr_listing = 0.0, time_dopts = 0.0, time_dosp = 0.0, &
-                 time_dosp_av = 0.0, time_dots = 0.0, time_do2d_xy = 0.0, &
-                 time_do2d_xz = 0.0, time_do2d_yz = 0.0, time_do3d = 0.0, &
-                 time_do_av = 0.0, time_do_sla = 0.0, time_dvrp = 0.0, &
-                 time_restart = 9999999.9, time_run_control = 0.0,&
-                 time_since_reference_point, top_heatflux = 9999999.9, &
-                 top_momentumflux_u = 9999999.9, &
-                 top_momentumflux_v = 9999999.9, top_salinityflux = 9999999.9, &
-                 ug_surface = 0.0, u_bulk = 0.0, u_gtrans = 0.0, &
-                 vg_surface = 0.0, vpt_reference = 9999999.9, &
-                 v_bulk = 0.0, v_gtrans = 0.0, wall_adjustment_factor = 1.8, &
-                 z_max_do2d = -1.0, z0h_factor = 1.0
-
-    REAL(wp) ::  do2d_xy_last_time(0:1) = -1.0, do2d_xz_last_time(0:1) = -1.0, &
-                 do2d_yz_last_time(0:1) = -1.0, dpdxy(1:2) = 0.0, &
-                 dt_domask(max_masks) = 9999999.9, lad_vertical_gradient(10) = 0.0,&
-                 lad_vertical_gradient_level(10) = -9999999.9, &
+    REAL(wp) ::  advected_distance_x = 0.0_wp, advected_distance_y = 0.0_wp, &
+                 alpha_surface = 0.0_wp, atmos_ocean_sign = 1.0_wp, &
+                 averaging_interval = 0.0_wp, averaging_interval_pr = 9999999.9_wp, &
+                 averaging_interval_sp = 9999999.9_wp, bc_pt_t_val, bc_q_t_val, &
+                 bottom_salinityflux = 0.0_wp, &
+                 building_height = 50.0_wp, building_length_x = 50.0_wp, &
+                 building_length_y = 50.0_wp, building_wall_left = 9999999.9_wp, &
+                 building_wall_south = 9999999.9_wp, canyon_height = 50.0_wp, &
+                 canyon_width_x = 9999999.9_wp, canyon_width_y = 9999999.9_wp, &
+                 canyon_wall_left = 9999999.9_wp, canyon_wall_south = 9999999.9_wp, &
+                 cthf = 0.0_wp, cfl_factor = -1.0_wp, cos_alpha_surface, &
+                 coupling_start_time = 0.0_wp, disturbance_amplitude = 0.25_wp, &
+                 disturbance_energy_limit = 0.01_wp, &
+                 disturbance_level_b = -9999999.9_wp, &
+                 disturbance_level_t = -9999999.9_wp, &
+                 dp_level_b = 0.0_wp, drag_coefficient = 0.0_wp, &
+                 dt = -1.0_wp, dt_averaging_input = 0.0_wp, &
+                 dt_averaging_input_pr = 9999999.9_wp, dt_coupling = 9999999.9_wp, &
+                 dt_data_output = 9999999.9_wp, &
+                 dt_data_output_av = 9999999.9_wp, dt_disturb = 9999999.9_wp, &
+                 dt_dopr = 9999999.9_wp, dt_dopr_listing = 9999999.9_wp, &
+                 dt_dopts = 9999999.9_wp, dt_dosp = 9999999.9_wp, dt_dots = 9999999.9_wp, &
+                 dt_do2d_xy = 9999999.9_wp, dt_do2d_xz = 9999999.9_wp, &
+                 dt_do2d_yz = 9999999.9_wp, dt_do3d = 9999999.9_wp, dt_dvrp = 9999999.9_wp, &
+                 dt_max = 20.0_wp, dt_micro = -1.0_wp, dt_restart = 9999999.9_wp, &
+                 dt_run_control = 60.0_wp, dt_3d = -1.0_wp, dz = -1.0_wp, &
+                 dz_max = 9999999.9_wp, dz_stretch_factor = 1.08_wp, &
+                 dz_stretch_level = 100000.0_wp, e_init = 0.0_wp, e_min = 0.0_wp, &
+                 end_time = 0.0_wp, &
+                 f = 0.0_wp, fs = 0.0_wp, g = 9.81_wp, inflow_damping_height = 9999999.9_wp, &
+                 inflow_damping_width = 9999999.9_wp, kappa = 0.4_wp, km_constant = -1.0_wp,&
+                 lad_surface = 0.0_wp, leaf_surface_concentration = 0.0_wp, &
+                 mask_scale_x = 1.0_wp, mask_scale_y = 1.0_wp, mask_scale_z = 1.0_wp, &
+                 maximum_cpu_time_allowed = 0.0_wp,  &
+                 molecular_viscosity = 1.461E-5_wp, &
+                 old_dt = 1.0E-10_wp, omega = 7.29212E-5_wp, omega_sor = 1.8_wp, &
+                 particle_maximum_age = 9999999.9_wp, &
+                 phi = 55.0_wp, prandtl_number = 1.0_wp, &
+                 precipitation_amount_interval = 9999999.9_wp, prho_reference, &
+                 pt_damping_factor = 0.0_wp, pt_damping_width = 0.0_wp, &
+                 pt_reference = 9999999.9_wp, pt_slope_offset = 0.0_wp, &
+                 pt_surface = 300.0_wp, pt_surface_initial_change = 0.0_wp, &
+                 q_surface = 0.0_wp, q_surface_initial_change = 0.0_wp, &
+                 rayleigh_damping_factor = -1.0_wp, rayleigh_damping_height = -1.0_wp, &
+                 recycling_width = 9999999.9_wp, residual_limit = 1.0E-4_wp, &
+                 restart_time = 9999999.9_wp, rho_reference, rho_surface, &
+                 rif_max = 1.0_wp, rif_min = -5.0_wp, roughness_length = 0.1_wp, &
+                 sa_surface = 35.0_wp, scalar_exchange_coefficient = 0.0_wp, &
+                 simulated_time = 0.0_wp, simulated_time_at_begin, sin_alpha_surface, &
+                 skip_time_data_output = 0.0_wp, skip_time_data_output_av = 9999999.9_wp,&
+                 skip_time_dopr = 9999999.9_wp, skip_time_dosp = 9999999.9_wp, &
+                 skip_time_do2d_xy = 9999999.9_wp, skip_time_do2d_xz = 9999999.9_wp, &
+                 skip_time_do2d_yz = 9999999.9_wp, skip_time_do3d = 9999999.9_wp, &
+                 surface_heatflux = 9999999.9_wp, surface_pressure = 1013.25_wp, &
+                 surface_scalarflux = 9999999.9_wp, surface_waterflux = 9999999.9_wp, &
+                 s_surface = 0.0_wp, s_surface_initial_change = 0.0_wp, &
+                 termination_time_needed = -1.0_wp, time_coupling = 0.0_wp, &
+                 time_disturb = 0.0_wp, time_dopr = 0.0_wp, time_dopr_av = 0.0_wp, &
+                 time_dopr_listing = 0.0_wp, time_dopts = 0.0_wp, time_dosp = 0.0_wp, &
+                 time_dosp_av = 0.0_wp, time_dots = 0.0_wp, time_do2d_xy = 0.0_wp, &
+                 time_do2d_xz = 0.0_wp, time_do2d_yz = 0.0_wp, time_do3d = 0.0_wp, &
+                 time_do_av = 0.0_wp, time_do_sla = 0.0_wp, time_dvrp = 0.0_wp, &
+                 time_restart = 9999999.9_wp, time_run_control = 0.0_wp,&
+                 time_since_reference_point, top_heatflux = 9999999.9_wp, &
+                 top_momentumflux_u = 9999999.9_wp, &
+                 top_momentumflux_v = 9999999.9_wp, top_salinityflux = 9999999.9_wp, &
+                 ug_surface = 0.0_wp, u_bulk = 0.0_wp, u_gtrans = 0.0_wp, &
+                 vg_surface = 0.0_wp, vpt_reference = 9999999.9_wp, &
+                 v_bulk = 0.0_wp, v_gtrans = 0.0_wp, wall_adjustment_factor = 1.8_wp, &
+                 z_max_do2d = -1.0_wp, z0h_factor = 1.0_wp
+
+    REAL(wp) ::  do2d_xy_last_time(0:1) = -1.0_wp, do2d_xz_last_time(0:1) = -1.0_wp, &
+                 do2d_yz_last_time(0:1) = -1.0_wp, dpdxy(1:2) = 0.0_wp, &
+                 dt_domask(max_masks) = 9999999.9_wp, lad_vertical_gradient(10) = 0.0_wp,&
+                 lad_vertical_gradient_level(10) = -9999999.9_wp, &
                  mask_scale(3), &
-                 pt_vertical_gradient(10) = 0.0, &
-                 pt_vertical_gradient_level(10) = -9999999.9, &
-                 q_vertical_gradient(10) = 0.0, &
-                 q_vertical_gradient_level(10) = -1.0, &
-                 s_vertical_gradient(10) = 0.0, &
-                 s_vertical_gradient_level(10) = -1.0, &
-                 sa_vertical_gradient(10) = 0.0, &
-                 sa_vertical_gradient_level(10) = -9999999.9, &
-                 skip_time_domask(max_masks) = 9999999.9, threshold(20) = 0.0, &
-                 time_domask(max_masks) = 0.0, &
-                 tsc(10) = (/ 1.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 /), &
-                 u_profile(100) = 9999999.9, uv_heights(100) = 9999999.9, &
-                 v_profile(100) = 9999999.9, &
-                 ug_vertical_gradient(10) = 0.0, &
-                 ug_vertical_gradient_level(10) = -9999999.9, &
-                 vg_vertical_gradient(10) = 0.0, &
-                 vg_vertical_gradient_level(10) = -9999999.9, &
-                 volume_flow(1:2) = 0.0, volume_flow_area(1:2) = 0.0, &
-                 volume_flow_initial(1:2) = 0.0, wall_heatflux(0:4) = 0.0, &
-                 wall_humidityflux(0:4) = 0.0, wall_nrflux(0:4) = 0.0, &
-                 wall_qflux(0:4) = 0.0, wall_qrflux(0:4) = 0.0, &
-                 wall_salinityflux(0:4) = 0.0, wall_scalarflux(0:4) = 0.0, &
-                 subs_vertical_gradient(10) = 0.0, &
-                 subs_vertical_gradient_level(10) = -9999999.9
+                 pt_vertical_gradient(10) = 0.0_wp, &
+                 pt_vertical_gradient_level(10) = -9999999.9_wp, &
+                 q_vertical_gradient(10) = 0.0_wp, &
+                 q_vertical_gradient_level(10) = -1.0_wp, &
+                 s_vertical_gradient(10) = 0.0_wp, &
+                 s_vertical_gradient_level(10) = -1.0_wp, &
+                 sa_vertical_gradient(10) = 0.0_wp, &
+                 sa_vertical_gradient_level(10) = -9999999.9_wp, &
+                 skip_time_domask(max_masks) = 9999999.9_wp, threshold(20) = 0.0_wp, &
+                 time_domask(max_masks) = 0.0_wp, &
+                 tsc(10) = (/ 1.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp /), &
+                 u_profile(100) = 9999999.9_wp, uv_heights(100) = 9999999.9_wp, &
+                 v_profile(100) = 9999999.9_wp, &
+                 ug_vertical_gradient(10) = 0.0_wp, &
+                 ug_vertical_gradient_level(10) = -9999999.9_wp, &
+                 vg_vertical_gradient(10) = 0.0_wp, &
+                 vg_vertical_gradient_level(10) = -9999999.9_wp, &
+                 volume_flow(1:2) = 0.0_wp, volume_flow_area(1:2) = 0.0_wp, &
+                 volume_flow_initial(1:2) = 0.0_wp, wall_heatflux(0:4) = 0.0_wp, &
+                 wall_humidityflux(0:4) = 0.0_wp, wall_nrflux(0:4) = 0.0_wp, &
+                 wall_qflux(0:4) = 0.0_wp, wall_qrflux(0:4) = 0.0_wp, &
+                 wall_salinityflux(0:4) = 0.0_wp, wall_scalarflux(0:4) = 0.0_wp, &
+                 subs_vertical_gradient(10) = 0.0_wp, &
+                 subs_vertical_gradient_level(10) = -9999999.9_wp
 
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  dp_smooth_factor
 
     REAL(wp), DIMENSION(max_masks,mask_xyz_dimension) :: &
-            mask_x = -1.0, mask_y = -1.0, mask_z = -1.0
+            mask_x = -1.0_wp, mask_y = -1.0_wp, mask_z = -1.0_wp
     REAL(wp), DIMENSION(max_masks,3) ::                  &
-            mask_x_loop = -1.0, mask_y_loop = -1.0, mask_z_loop = -1.0
+            mask_x_loop = -1.0_wp, mask_y_loop = -1.0_wp, mask_z_loop = -1.0_wp
     
 !
@@ -787,42 +785,42 @@
                 use_seperate_pe_for_dvrp_output = .FALSE.
 
-    REAL(wp)    ::  clip_dvrp_l = 9999999.9, clip_dvrp_n = 9999999.9, &
-                    clip_dvrp_r = 9999999.9, clip_dvrp_s = 9999999.9, &
-                    superelevation = 1.0, superelevation_x = 1.0,     &
-                    superelevation_y = 1.0, vc_alpha = 38.0
-
-    REAL(wp), DIMENSION(2) ::  color_interval = (/ 0.0, 1.0 /), &
-                               dvrpsize_interval = (/ 0.0, 1.0 /)
-
-    REAL(wp), DIMENSION(3) ::  groundplate_color = (/ 0.0, 0.6, 0.0 /), &
-                               topography_color = (/ 0.8, 0.7, 0.6 /)
+    REAL(wp)    ::  clip_dvrp_l = 9999999.9_wp, clip_dvrp_n = 9999999.9_wp, &
+                    clip_dvrp_r = 9999999.9_wp, clip_dvrp_s = 9999999.9_wp, &
+                    superelevation = 1.0_wp, superelevation_x = 1.0_wp,     &
+                    superelevation_y = 1.0_wp, vc_alpha = 38.0_wp
+
+    REAL(wp), DIMENSION(2) ::  color_interval = (/ 0.0_wp, 1.0_wp /), &
+                               dvrpsize_interval = (/ 0.0_wp, 1.0_wp /)
+
+    REAL(wp), DIMENSION(3) ::  groundplate_color = (/ 0.0_wp, 0.6_wp, 0.0_wp /), &
+                               topography_color = (/ 0.8_wp, 0.7_wp, 0.6_wp /)
 
 #if defined( __decalpha )
     REAL(wp), DIMENSION(2,10)  ::  slicer_range_limits_dvrp = RESHAPE( (/      &
-                                   -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
-                                   -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, -1.0, 1.0, &
-                                   -1.0, 1.0, -1.0, 1.0 /), (/ 2, 10 /) )
+                                   -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, &
+                                   -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp, &
+                                   -1.0_wp, 1.0_wp, -1.0_wp, 1.0_wp /), (/ 2, 10 /) )
 
     REAL(wp), DIMENSION(3,10)  ::  isosurface_color = RESHAPE( (/                 &
-                                   0.9, 0.9, 0.9,  0.8, 0.1, 0.1,  0.1, 0.1, 0.8, &
-                                   0.1, 0.8, 0.1,  0.6, 0.1, 0.1,  0.1, 0.1, 0.6, &
-                                   0.1, 0.6, 0.1,  0.4, 0.1, 0.1,  0.1, 0.1, 0.4, &
-                                   0.1, 0.4, 0.1 /), (/ 3, 10 /) )
+                                   0.9_wp, 0.9_wp, 0.9_wp,  0.8_wp, 0.1_wp, 0.1_wp,  0.1_wp, 0.1_wp, 0.8_wp, &
+                                   0.1_wp, 0.8_wp, 0.1_wp,  0.6_wp, 0.1_wp, 0.1_wp,  0.1_wp, 0.1_wp, 0.6_wp, &
+                                   0.1_wp, 0.6_wp, 0.1_wp,  0.4_wp, 0.1_wp, 0.1_wp,  0.1_wp, 0.1_wp, 0.4_wp, &
+                                   0.1_wp, 0.4_wp, 0.1_wp /), (/ 3, 10 /) )
 
     REAL(sp), DIMENSION(2,100) ::  interval_values_dvrp, interval_h_dvrp =      &
-                                   RESHAPE( (/ 270.0, 225.0, 225.0, 180.0,      &
-                                                70.0,  25.0,  25.0, -25.0,      &
-                                               ( 0.0, i9 = 1, 192 ) /),         &
+                                   RESHAPE( (/ 270.0_sp, 225.0_sp, 225.0_sp, 180.0_sp,      &
+                                                70.0_sp,  25.0_sp,  25.0_sp, -25.0_sp,      &
+                                               ( 0.0_sp, i9 = 1, 192 ) /),         &
                                             (/ 2, 100 /) ),                     &
-                                   interval_l_dvrp = 0.5, interval_s_dvrp = 1.0,&
-                                   interval_a_dvrp = 0.0,                       &
+                                   interval_l_dvrp = 0.5_sp, interval_s_dvrp = 1.0_sp,&
+                                   interval_a_dvrp = 0.0_sp,                       &
                                    interval_values_dvrp_prt,                    &
                                    interval_h_dvrp_prt = RESHAPE(               &
-                                   (/ 270.0, 225.0, 225.0, 180.0, 70.0, 25.0,   &
-                                      25.0, -25.0, ( 0.0, i9 = 1, 192 ) /),     &
+                                   (/ 270.0_sp, 225.0_sp, 225.0_sp, 180.0_sp, 70.0_sp, 25.0_sp,   &
+                                      25.0_sp, -25.0_sp, ( 0.0_sp, i9 = 1, 192 ) /),     &
                                                    (/ 2, 100 /) ),              &
-                                   interval_l_dvrp_prt = 0.5,                   &
-                                   interval_s_dvrp_prt = 1.0,                   &
-                                   interval_a_dvrp_prt = 0.0
+                                   interval_l_dvrp_prt = 0.5_sp,                   &
+                                   interval_s_dvrp_prt = 1.0_sp,                   &
+                                   interval_a_dvrp_prt = 0.0_sp
 #else
     REAL(wp), DIMENSION(2,10)     ::  slicer_range_limits_dvrp
